/***************************** Include Files *********************************/
#include "xil_types.h"
/**************************** Type Definitions *******************************/
typedef enum HttpMethod {
    HTTP_GET,
    HTTP_POST,
    HTTP_OPTIONS,
    HTTP_UNKNOWN
} HttpMethod_t;

typedef enum WebCommand {
    UPDATE_MULTIBOOT_CMD,
    UPDATE_GOLDEN_CMD,
    EVENT_STREAM_URL,
    UNKNOWN_CMD
} WebCommand_t;

typedef struct HttpRequest {
    HttpMethod_t Method;
    WebCommand_t Command;
    u32 ContentLength;
} HttpRequest_t;

int respond_http_options(int sd);
int respond_http_post(int sd, HttpRequest_t *Request);
int respond_http_get(int sd, HttpRequest_t *Request);

int do_http_200(int sd, const char *Message, char* MessageType); /* 200 OK */
int do_http_400(int sd);                                   /* 400 Bad Request */
int do_http_501(int sd);                                   /* 501 Not Implemented */
int send_sse_event(int sd, char *Message);
